summaryrefslogtreecommitdiffstats
path: root/desktop/anki/anki.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'desktop/anki/anki.SlackBuild')
-rw-r--r--desktop/anki/anki.SlackBuild101
1 files changed, 67 insertions, 34 deletions
diff --git a/desktop/anki/anki.SlackBuild b/desktop/anki/anki.SlackBuild
index cffdd710ec..3e91144fc5 100644
--- a/desktop/anki/anki.SlackBuild
+++ b/desktop/anki/anki.SlackBuild
@@ -1,67 +1,100 @@
-#!/bin/sh
+#!/bin/bash
# Slackware build script for anki
# Written by Giuseppe Scalzi <giuseppe[at]osgate[dot]org>
+# Updated for new Anki build scheme by Caterino Tommaso, T.O.P. (2023)
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
PRGNAM=anki
-VERSION=${VERSION:-2.0.52}
-BUILD=${BUILD:-1}
+VERSION=${VERSION:-2.1.65}
+BUILD=${BUILD:-2}
TAG=${TAG:-_SBo}
-ARCH="noarch"
+PKGTYPE=${PKGTYPE:-tgz}
+
+# Find ARCH
+if [ -z "$ARCH" ]; then
+ ARCH=$( uname -m )
+fi
+
+# Bail out if not x86_64
+if [ "$ARCH" != x86_64 ]; then
+ echo "Architecture $ARCH is not supported" >&2
+ exit 1
+fi
+
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
-CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
-set -e
+# Exit for errors or unset variables below.
+set -eu
rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
-cd $TMP
-rm -rf $PRGNAM-$VERSION
-tar xvf $CWD/$PRGNAM-$VERSION-source.tgz
-cd $PRGNAM-$VERSION
+cd $PKG
+python3 -m venv usr
+
+( cd usr ; bin/pip3 install -v --no-deps $CWD/aqt*.whl $CWD/anki*.whl )
+
chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
-o -perm 511 \) -exec chmod 755 {} \; -o \
- \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
- -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
-
-# Doing this manually since the included Makefile isn't very flexible (it always
-# installs the anki binary as ${DESTDIR}${PREFIX}/local/bin/anki for example),
-# and there isn't a lot of things that need copying.
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
-mkdir -p $PKG/usr/bin
-cp -a runanki $PKG/usr/bin/anki
+find $PKG/usr -not -name lib -not -name bin -mindepth 1 -maxdepth 1 \
+ -execdir rm -rf '{}' \+
-mkdir -p $PKG/usr/share/pixmaps
-cp -a anki.xpm anki.png $PKG/usr/share/pixmaps/
+find $PKG/usr/bin $PKG/usr/lib/python3.9/site-packages \
+ -mindepth 1 -maxdepth 1 \
+ -not -name "_aqt*" \
+ -not -name "aqt*" \
+ -not -name "anki*" \
+ -execdir rm -rf '{}' \+
-mkdir -p $PKG/usr/share/mime/packages
-cat anki.xml > $PKG/usr/share/mime/packages/anki.xml
+mv -v $PKG/usr/lib $PKG/usr/lib64
-mkdir -p $PKG/usr/share/applications
-cp -a anki.desktop $PKG/usr/share/applications/
+# delete line 1, insert python bang
+sed -i '1d;2i #!/usr/bin/python3' $PKG/usr/bin/anki
-mkdir -p $PKG/usr/man/man1
-cp -a anki.1 $PKG/usr/man/man1
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
-find $PKG/usr/man -type f -exec gzip -9 {} \;
-for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+install -vD -m 0644 $CWD/anki/anki.{png,xpm} -t $PKG/usr/share/pixmaps
+install -vD -m 0644 $CWD/anki/anki.desktop -t $PKG/usr/share/applications
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-cp -a LICENSE LICENSE.logo README README.development $PKG/usr/doc/$PRGNAM-$VERSION
+cp $CWD/README $PKG/usr/doc/$PRGNAM-$VERSION
+chown root:root $PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
-mkdir -p $PKG/usr/share/anki
-cp -av anki aqt designer locale oldanki thirdparty $PKG/usr/share/anki/
-
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
-cd $PKG
-/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE